﻿#include "stdafx.h"
#include "RecvMemoDlg.h"
#include "json.h"
#include "NeMessengerDlg.h"
#include "afxhtml.h"
#include <winnls.h>
#include "resource.h"
#include "ChatDialogManager.h"
#include "SendNoteMananger.h"
#include "ReceivedNoteManager.h"
#include <mmsystem.h> 
#include "main_frame.hpp"
#include "ProfileWnd.h"
#include <ftlWindow.h>

#define	ID_DOWNLOAD	    (3000)
#define	ID_DELLIST	    (3001)

#define BTN_TEXT_COLOR RGB(94, 95, 109)

IMPLEMENT_DYNAMIC(CRecvMemoDlg, CSkinDialog)

CRecvMemoDlg::CRecvMemoDlg(UINT64 noteID, const NoteInfo& noteInfo)
: CSkinDialog(CRecvMemoDlg::IDD, CWnd::GetDesktopWindow())
, m_lMemoID(noteID)
, m_bInitializeSuccess(false)
, m_bFlashFlag(false)
, m_noteInfo(noteInfo)
, m_bReadStatus(false)
, m_noteCount(0)
, m_bTopMost(FALSE)
{
	EnableCascade(true);
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_rcMemoInfoBorder.SetRectEmpty();
    m_rcMemoViewBorder.SetRectEmpty();
    m_rcFileBorder.SetRectEmpty();
    //m_nFileCount = 0;
    //glpDisp = NULL;
    m_rcButtonBG.SetRectEmpty();
    m_rcFileListBG.SetRectEmpty();
	m_bUserBottomButton = FALSE;
}

CRecvMemoDlg::~CRecvMemoDlg()
{
}

BOOL CRecvMemoDlg::Create()
{
	return CSkinDialog::Create(IDD_MEMO_RECV_DIALOG, CWnd::GetDesktopWindow());
}

void CRecvMemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BUTTON_REPLY, m_btnReply);
	DDX_Control(pDX, IDC_BUTTON_REPLYALL, m_btnAllReply);
	DDX_Control(pDX, IDC_BUTTON_FORWARD, m_btnForward);
	DDX_Control(pDX, IDC_BUTTON_IM, m_btnIM);
	DDX_Control(pDX, IDC_BUTTON_DEL, m_btnDel);
	DDX_Control(pDX, IDC_BUTTON_PRT, m_btnPRT);	
	DDX_Control(pDX, IDC_MEMOVIEW_EXPLORER, m_ctrlMemoViewer);
}


BEGIN_MESSAGE_MAP(CRecvMemoDlg, CSkinDialog)
	ON_BN_CLICKED(IDC_BUTTON_REPLY, &CRecvMemoDlg::OnBnClickedButtonReply)
	ON_BN_CLICKED(IDC_BUTTON_REPLYALL, &CRecvMemoDlg::OnBnClickedButtonReplyall)
	ON_BN_CLICKED(IDC_BUTTON_FORWARD, &CRecvMemoDlg::OnBnClickedButtonForward)
	ON_BN_CLICKED(IDC_BUTTON_DEL, &CRecvMemoDlg::OnBnClickedButtonDel)
	ON_BN_CLICKED(IDC_BUTTON_IM, &CRecvMemoDlg::OnBnClickedButtonIm)
	ON_BN_CLICKED(IDC_BUTTON_PRT, &CRecvMemoDlg::OnBnClickedButtonPrt)
	ON_WM_PAINT()
	ON_WM_DESTROY()
	ON_WM_ERASEBKGND()	
	ON_WM_SIZE()	
	ON_MESSAGE(UM_RECVMEMO_DOWNLOAD, OnRecvMemoFileDownload)
	ON_WM_SETFOCUS()
	ON_WM_ACTIVATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_NCLBUTTONDOWN()
	ON_WM_TIMER()
	ON_WM_NCHITTEST()
	ON_MESSAGE(WM_CLICKCUSTOMBTN, OnBnClickedRecvMemoMenuButton)
	ON_COMMAND(ID_RECVMEMO_TOP, &CRecvMemoDlg::OnMenuTopMost)
	ON_COMMAND(ID_RECVMEMO_REPLY, &CRecvMemoDlg::OnMenuReply)
	ON_COMMAND(ID_RECVMEMO_ALLREPLY, &CRecvMemoDlg::OnMenuAllReply)
	ON_COMMAND(ID_RECVMEMO_FORWARD, &CRecvMemoDlg::OnMenuForward)
	ON_COMMAND(ID_RECVMEMO_DEL, &CRecvMemoDlg::OnMenuRecvDel)
	ON_COMMAND(ID_RECVMEMO_CHAT, &CRecvMemoDlg::OnMenuChat)
END_MESSAGE_MAP()

void CRecvMemoDlg::OnPaint()
{
	CPaintDC dc(this);
}


LRESULT CRecvMemoDlg::OnNcHitTest(CPoint point)
{
	int ret = CDialog::OnNcHitTest(point);
	if((HTTOP == ret || HTBOTTOM == ret || HTLEFT == ret || HTRIGHT == ret || HTBOTTOMLEFT == ret || HTBOTTOMRIGHT == ret || HTTOPLEFT == ret || HTTOPRIGHT == ret) 
		&& m_bMaxWnd)
		return HTCLIENT;
	return ret;
}
BOOL CRecvMemoDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);
/*
	CRect rcWindow(0, 0, 0, 0);
	GetWindowRect(&rcWindow);
	rcWindow.right = rcWindow.left + RMD_DEF_MIN_SIZE_WIDTH;
	rcWindow.bottom = rcWindow.top + RMD_DEF_MIN_SIZE_HEIGHT;
	MoveWindow(rcWindow, TRUE);
*/
	__ResourceLoad(TRUE);
	_EnableAllBtnHandCurser();
	ModifyStyle(0, WS_CLIPCHILDREN);

	CString strTitle =  Conversion::Utf8ToWide(m_noteInfo.title).c_str();
	strTitle.Replace(_T("&lt;"), _T("<"));
	strTitle.Replace(_T("&gt;"), _T(">"));
	strTitle.Replace(_T("&amp;"), _T("&"));
	strTitle.Replace(_T("&quot;"), _T("\""));
	strTitle.Replace(_T("&#39;"), _T("'"));

	SetWindowText(strTitle);
	SetShowTitle(FALSE);
	SetWindowMinSize(RMD_DEF_MIN_SIZE_WIDTH, RMD_DEF_MIN_SIZE_HEIGHT); 
	SetExitBtnActHide(FALSE); 
	SetMoveTransParent(FALSE); 
	
	SetDialogShowWindowText(true);
	SetDialogWindowText(strTitle);

	SetWindowTextColor(CColorConvert::HEX2Color(0xFFC8D1D8));
	SetWindowTextFontHeight(12);

	GET_APP()->SetWindowRegion(this);
	m_bInitializeSuccess = true;

	m_ctrlMemoViewer.NewViewer(m_lMemoID);

	InitListFile();
	ReSizeCtrl();
	InitControls();
	SetSkin();

	SetLastPositionAndSize(this, _T("ReceiveMemoDialog"));

	//It's strange to call restore here.
	//In order to set handled, add function "SetRestoreHandled" here.
	Restore(this, true, _T("ReceiveMemoDialog"), Both, this);
	SetRestoreHandled();

	if(GET_CONFIG()->GetMemoAlarmType() == 0)
		ReadNote();

	int nAlarmtype = GET_CONFIG()->GetMemoAlarmType();
	if(nAlarmtype != 3 )
	{
		//g_pos_recvmemodlg.InitWindowInfo(m_hWnd);
	}

	return TRUE;
}

// 답장
void CRecvMemoDlg::OnBnClickedButtonReply()
{

#if _DEBUG && defined(TEST_SEND_MEMO)
	SetTimer(TIMER_TEST_SENDMEMO_AUTO_REPLY, 3000, NULL);
#endif

	m_btnReply.EnableWindow(FALSE);
	GET_APP()->m_pSendNoteManager->MakeMemoSendDlg(_T("reply"), m_lMemoID, this);
	m_btnReply.EnableWindow(TRUE);
}

// 전체답장
void CRecvMemoDlg::OnBnClickedButtonReplyall()
{
	m_btnAllReply.EnableWindow(FALSE);
	GET_APP()->m_pSendNoteManager->MakeMemoSendDlg(_T("replyAll"), m_lMemoID, this);
	m_btnAllReply.EnableWindow(TRUE);
}

// 전달
void CRecvMemoDlg::OnBnClickedButtonForward()
{
	m_btnForward.EnableWindow(FALSE);
	GET_APP()->m_pSendNoteManager->MakeMemoSendDlg(_T("forward"), m_lMemoID, this);
	//GET_APP()->m_pSendNoteManager->MakeMemoSendDlg(_T("forward"), m_lMemoID, this);
	m_btnForward.EnableWindow(TRUE);
}

void CRecvMemoDlg::OnBnClickedButtonDel()
{
	m_btnDel.EnableWindow(FALSE);
	if( NMessageBox(this, LoadStringFromResource(IDS_STRING465), L"Ntalk biz", MB_YESNO) == IDYES )
	{
		
		g_pMessengerActor->GetWASActor()->RequestDeleteNote( m_lMemoID, GetLanguageString().c_str(), &m_trid );

		if( NULL != GET_APP()->m_pReceivedNoteManager )
		{
			GET_APP()->m_pReceivedNoteManager->Remove(this);
			this->DestroyWindow();
		}
	}
	else
	{
		m_btnDel.EnableWindow(TRUE);
	}
}

void CRecvMemoDlg::OnBnClickedButtonIm()
{
	m_btnIM.EnableWindow(FALSE);
	std::wstring userId = Conversion::Utf8ToWide(m_noteInfo.sender.userId);
	std::wstring userName = Conversion::Utf8ToWide(m_noteInfo.sender.userName);
	GET_APP()->m_pChatDialogManager->CreateSingleMemberChat(userId.c_str(), userName.c_str());	
	m_btnIM.EnableWindow(TRUE);
}

void CRecvMemoDlg::OnBnClickedButtonPrt()
{
	m_ctrlMemoViewer.Print();
}


void CRecvMemoDlg::OnDestroy()
{
	//g_pos_recvmemodlg.UpdateDlgNum();
	CSkinDialog::OnDestroy();
}

BOOL CRecvMemoDlg::OnEraseBkgnd(CDC* pDC)
{
	 //여기서 백그라운드 그린다.[2012.4.9 yangjae.park@nhn.com]
	CRect rt(0, 0, 0, 0);
	GetClientRect(&rt);
	int psWidth = rt.Width();
	int psHeight = rt.Height();
	int nPX = rt.left;
	int nPY = rt.top;
	CRect rtPS(nPX, nPY, nPX + psWidth, nPY + psHeight);
	int nWndWidth = rt.Width();
	int nWndHeight = rt.Height();
	CRect rcList(0, 0, 0, 0);
	rcList.SetRect(0-1,rt.bottom -RMD_DEF_FILE_BOTTOM,rt.Width()+2,rt.Height()+1);
	m_rcButtonBG.SetRect(0,0,rt.Width(),RMD_DEF_TOP_BK_POS_HEIGHT);
	m_rcButtonBG.InflateRect(1,1);
	
	HDC hdc = pDC->GetSafeHdc();	
	HDC	hdcMemory = CreateCompatibleDC(hdc);

	if (hdcMemory == NULL)
		return FALSE;

	HBITMAP hbmpMem = CreateCompatibleBitmap(hdc, psWidth, psHeight);
	HGDIOBJ hbmpOld = ::SelectObject(hdcMemory,  hbmpMem);

	if (hbmpMem == NULL)
		return FALSE;

	UtilFillSolidRect(hdcMemory,rt,RGB(255,255,255));
	UtilFillSolidRect(hdcMemory,m_rcButtonBG,COMMON_BORDER_COLOR);
	m_rcButtonBG.DeflateRect(1,1);
	UtilFillSolidRect(hdcMemory,m_rcButtonBG,TOP_BK_COLOR);		
	UtilFillSolidRect(hdcMemory,rcList,COMMON_BORDER_COLOR);
	rcList.DeflateRect(1,1);
	UtilFillSolidRect(hdcMemory,rcList,RGB(255,255,255));

	BitBlt(pDC->GetSafeHdc(), nPX, nPY, psWidth, psHeight, hdcMemory, 0, 0, SRCCOPY);

	::SelectObject(hdcMemory, hbmpOld);
	::DeleteObject(hbmpMem);

	::DeleteDC(hdcMemory);

	return FALSE;
}

BOOL CRecvMemoDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_NCLBUTTONDOWN || pMsg->message == WM_LBUTTONDOWN)
	{
		ReadNote();
	}
	if(pMsg->message == WM_KEYDOWN)
	{
		ReadNote();

		if(pMsg->wParam == VK_ESCAPE)
		{
			if (g_pProfileWnd != NULL && IsWindow(g_pProfileWnd->GetHWND()) && m_ctrlMemoViewer.GetSafeHwnd() == g_pProfileWnd->GetParentHwnd())
			{
				g_pProfileWnd->CloseProfileWnd();
			}			
			else
			{
				GET_MESSENGER_DLG()->SendMessage(WM_EXITRECVMEMODLG, 0, (LPARAM)this);
			}
			
			return TRUE;
		}
		else if(pMsg->wParam == VK_RETURN)
		{			
			return TRUE;
		}
		else if(pMsg->wParam == VK_F5)
		{
			return TRUE;
		}
	}
	else if( IsCloseMsg(pMsg) )
	{
		GET_MESSENGER_DLG()->SendMessage(WM_EXITRECVMEMODLG, 0, (LPARAM)this);
		return TRUE;
	}

	return __super::PreTranslateMessage(pMsg);
}

void CRecvMemoDlg::OnSize(UINT nType, int cx, int cy)
{
	__super::OnSize(nType, cx, cy);

	ReSizeCtrl();
	::RedrawWindow(GetSafeHwnd(), NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_FRAME | RDW_ALLCHILDREN);

	if (m_ctrlMemoViewer.GetSafeHwnd()!=NULL)
	{
		m_ctrlMemoViewer.UpdateData(FALSE);
	}
}

void CRecvMemoDlg::ReSizeCtrl(void)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);
	// DeferWindowsPos로 한번에 모든 컨트롤을 동시에 옮긴다.  
	//그래야 깜박임이 적다. [2012.4.9 yangjae.park@nhn.com]
	HDWP hdwp = BeginDeferWindowPos(9);
	if(m_btnReply.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_btnReply.GetSafeHwnd(),NULL,RMD_DEF_REPLY_BUTTON_POS_X ,RMD_DEF_REPLY_BUTTON_POS_Y , RMD_DEF_REPLY_BUTTON_WIDTH,RMD_DEF_REPLY_BUTTON_HEIGHT ,SWP_NOZORDER);

	if (m_btnAllReply.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_btnAllReply.GetSafeHwnd(),NULL, RMD_DEF_ALL_REPLY_BUTTON_POS_X, RMD_DEF_ALL_REPLY_BUTTON_POS_Y, RMD_DEF_ALL_REPLY_BUTTON_WIDTH,RMD_DEF_ALL_REPLY_BUTTON_HEIGHT ,SWP_NOZORDER);

	if (m_btnForward.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_btnForward.GetSafeHwnd(),NULL,RMD_DEF_FORWARD_BUTTON_POS_X , RMD_DEF_FORWARD_BUTTON_POS_Y, RMD_DEF_FORWARD_BUTTON_WIDTH, RMD_DEF_FORWARD_BUTTON_HEIGHT,SWP_NOZORDER);


	if (m_btnDel.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_btnDel.GetSafeHwnd(),NULL,RMD_DEF_DEL_BUTTON_POS_X , RMD_DEF_DEL_BUTTON_POS_Y, RMD_DEF_DEL_BUTTON_WIDTH, RMD_DEF_DEL_BUTTON_HEIGHT,SWP_NOZORDER);
	
	if (m_btnIM.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_btnIM.GetSafeHwnd(),NULL, RMD_DEF_IM_BUTTON_POS_X,RMD_DEF_IM_BUTTON_POS_Y ,RMD_DEF_IM_BUTTON_WIDTH,RMD_DEF_IM_BUTTON_HEIGHT ,SWP_NOZORDER);

	if (m_btnPRT.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_btnPRT.GetSafeHwnd(),NULL,RMD_DEF_PRINT_BUTTON_POS_X ,RMD_DEF_PRINT_BUTTON_POS_Y ,RMD_DEF_PRINT_BUTTON_WIDTH,RMD_DEF_PRINT_BUTTON_HEIGHT ,SWP_NOZORDER);

	if (m_ctrlMemoViewer.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_ctrlMemoViewer.GetSafeHwnd(),NULL, RMD_DEF_VIEWER_POS_X,RMD_DEF_VIEWER_POS_Y ,rcClient.Width(),rcClient.Height()-RMD_RESIZE_MARGIN_HEIGHT ,SWP_NOZORDER);

	if (m_listFiles.GetSafeHwnd()!=NULL)
		DeferWindowPos(hdwp, m_listFiles.GetSafeHwnd(),NULL, RMD_DEF_FILE_LIST_POS_X,rcClient.bottom-RMD_DEF_FILE_BOTTOM ,rcClient.Width(),RMD_DEF_FILE_BOTTOM ,SWP_NOZORDER);

	EndDeferWindowPos(hdwp);
}

void CRecvMemoDlg::__ResourceLoad(BOOL bInit)
{

	if(bInit)
	{
		SetLeftTopPNG(GetAppImgFile(_T("img_title_l.png")));
		SetCenterTopPNG(GetAppImgFile(_T("img_title_c.png")));
		SetRightTopPNG(GetAppImgFile(_T("img_title_r.png")));

		SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
		SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

		SetLeftBottomPNG(GetAppImgFile(_T("img_bottom_l.png")));
		SetCenterBottomPNG(GetAppImgFile(_T("img_bottom_c.png")));
		SetRightBottomPNG(GetAppImgFile(_T("img_bottom_r.png")));

		//SetRestoreBitmaps(GetAppImgFile(_T("new_restore.bmp")),
		//	GetAppImgFile(_T("new_restore_over.bmp")), GetAppImgFile(_T("new_restore_click.bmp")));
		//SetMaxBitmaps(GetAppImgFile(_T("new_max.bmp")), GetAppImgFile(_T("new_max_over.bmp")), GetAppImgFile(_T("new_max_click.bmp")));
		//SetMinBitmaps(GetAppImgFile(_T("new_min.bmp")), GetAppImgFile(_T("new_min_over.bmp")), GetAppImgFile(_T("new_min_click.bmp")));
		SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
			GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));
		SetCloseEvent(TRUE);

		CString strText = L"";
		m_btnReply.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_01.bmp")),RGB(255,0,255));
		strText.LoadString(IDS_STRING248);
		m_btnReply.SetBmpText(strText);
		m_btnReply.SetBmpFont(&g_ftDefault9PT);
		m_btnReply.SetBmpFontColor(BTN_TEXT_COLOR);

		m_btnAllReply.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_02.bmp")),RGB(255,0,255));
		strText.LoadString(IDS_STRING249);
		m_btnAllReply.SetBmpText(strText);
		m_btnAllReply.SetBmpFont(&g_ftDefault9PT);
		m_btnAllReply.SetBmpFontColor(BTN_TEXT_COLOR);

		m_btnForward.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_02.bmp")),RGB(255,0,255));
		strText.LoadString(IDS_STRING250);
		m_btnForward.SetBmpText(strText);
		m_btnForward.SetBmpFont(&g_ftDefault9PT);
		m_btnForward.SetBmpFontColor(BTN_TEXT_COLOR);


		m_btnDel.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_02.bmp")),RGB(255,0,255));
		strText.LoadString(IDS_STRING251);
		m_btnDel.SetBmpText(strText);
		m_btnDel.SetBmpFont(&g_ftDefault9PT);
		m_btnDel.SetBmpFontColor(BTN_TEXT_COLOR);

		m_btnIM.SetBtnBitmapFile(GetAppImgFile(_T("btn_note_03.bmp")),RGB(255,0,255));
		strText.LoadString(IDS_STRING670);
		m_btnIM.SetBmpText(strText);
		m_btnIM.SetBmpFont(&g_ftDefault9PT);
		m_btnIM.SetBmpFontColor(BTN_TEXT_COLOR);

		m_btnPRT.SetBtnBitmapFile(GetAppImgFile(_T("btn_print.bmp")),RGB(255,0,255));
		//SetCustomBitmaps(GetAppImgFile(_T("new_main_menu.bmp")), GetAppImgFile(_T("new_main_menu_over.bmp")), GetAppImgFile(_T("new_main_menu_click.bmp")));
		//ShowCustomBtn(true);
	}
	else
	{
		m_btnReply.SetBmpText(LoadStringFromResource(IDS_STRING248));
		m_btnAllReply.SetBmpText(LoadStringFromResource(IDS_STRING249));
		m_btnForward.SetBmpText(LoadStringFromResource(IDS_STRING250));
		m_btnIM.SetBmpText(LoadStringFromResource(IDS_STRING670));
		m_btnDel.SetBmpText(LoadStringFromResource(IDS_STRING251));
		m_listFiles.SetTitle(LoadStringFromResource(IDS_STRING467));
		m_listFiles.__ResourceLoad();
		SendMessage(WM_SIZE, NULL, NULL);
	}
}

void CRecvMemoDlg::SetSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));		

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) {
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else {
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\Style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("WorkGroupDlg.ini"));
	CMDTARGET_RELEASE(pSchema);
}

BOOL CRecvMemoDlg::InitListFile() 
{
	CString strText = _T("");
	CRect rt(0, 0, 0, 0);

	CString strTmpClassName = _T("");
	strTmpClassName.Format(_T("Ntalk_MemoRecv_FileList_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);

	CRect rtFileList(0, 0, 0, 0);
	if (!m_listFiles.Create(strTmpClassName, _T("Ntalk_MemoRecv_FileList"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN, rtFileList, this, ID_RECVMEMO_FILE_ATTACH_LIST))
		return FALSE;

	m_listFiles.SetFontConfig(g_defaultFontFaceName, 11, FontStyleRegular, Color(255, 0, 0, 0));
	m_listFiles.SetTitle(LoadStringFromResource(IDS_STRING467));

	return TRUE;
}

void CRecvMemoDlg::InitControls()
{
	int nCntFile = m_noteInfo.attchFileVector.size();
	if (nCntFile > 0)
	{
		CString strAttachTextTh = _T("");		

		std::vector<AttachFileInfo>::const_iterator iter = m_noteInfo.attchFileVector.begin();
		for(; iter != m_noteInfo.attchFileVector.end(); iter++)
		{
			AttachFileInfo attachFI = *iter;

			CString strFileName = attachFI.fileName.c_str();
			if (strFileName.IsEmpty())
				continue;

			CString strDownloadURL = attachFI.downloadUrl.c_str();
			ULONGLONG dwFileSize = attachFI.fileSize;

			m_listFiles.AddFileItem(strDownloadURL, strFileName, dwFileSize);
		}
	}
}

LRESULT CRecvMemoDlg::OnRecvMemoFileDownload(WPARAM wParam, LPARAM lParam)
{
	int nItem = (int)lParam;

	return 0L;
}

bool CRecvMemoDlg::IsInitializeSuccess(void)
{
	return m_bInitializeSuccess;
}

void CRecvMemoDlg::SetReadOnly( BOOL bStatus )
{
	BOOL bValue = !bStatus;
	m_ctrlMemoViewer.EnableWindow(bValue);
	m_btnReply.EnableWindow(bValue);
	m_btnAllReply.EnableWindow(bValue);
	m_btnForward.EnableWindow(bValue);
	m_btnIM.EnableWindow(bValue);
	m_btnDel.EnableWindow(bValue);
	m_btnPRT.EnableWindow(bValue);
	m_listFiles.EnableWindow(bValue);
	Invalidate();
}

void CRecvMemoDlg::OnSetFocus(CWnd* pOldWnd)
{
	__super::OnSetFocus(pOldWnd);
	
	if (m_bFlashFlag)
	{
		StopFlashAndAdjustFocus();
        FTL::CFWinUtil::ActiveAndForegroundWindow(m_hWnd);
	}

	TRACE("%s %d\n", __FUNCTION__, __LINE__);
	
}

void CRecvMemoDlg::PostNcDestroy()
{
	CSkinDialog::PostNcDestroy();
	
	delete this;
}

void CRecvMemoDlg::DisplayFlashEffect()
{
	GTUserStatusType status = GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus();
	bool ShieldSoundOffline = false;

	if (!GET_CONFIG()->GetSoundNotOnline() && status != ustONLINE)
	{
		ShieldSoundOffline = true;
	}
	bool Forbidden1 =  (GET_CONFIG()->GetNoteSound() == 0)? true:false;
    bool Forbidden2 = (true == ShieldSoundOffline) ? true:false;
	bool Forbidden3 =  (GET_CONFIG()->GetNotifyOnMailOrSMS() == 0)? true:false;
    // Any one forbid of the three will off the sound, so all of them must be false; 
	if (!Forbidden1 && !Forbidden2 && !Forbidden3)
	{
		PlaySound(_T(".\\SOUNDS\\NT_tr.wav"), NULL, SND_ASYNC);
	}
	
	
	FlashWindowEx(FLASHW_ALL | FLASHW_TIMER, 0, 0);
	m_bFlashFlag = true;
}

void CRecvMemoDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	__super::OnActivate(nState, pWndOther, bMinimized);

	if (GET_CONFIG()->GetMemoAlarmType() == 1 && WA_ACTIVE == nState && IsIconic() != TRUE )
	{
		ReadNote();
	}

	if (m_bFlashFlag && WA_CLICKACTIVE == nState)	
	{
		StopFlashAndAdjustFocus();
	}
}

bool CRecvMemoDlg::IsCloseMsg( MSG* pMsg )
{
	bool result = false;
	/*if( (pMsg->message == WM_CLOSE) ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||
		(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) )
	{
		if ( (pMsg->message == WM_CLOSE || pMsg->wParam == SC_CLOSE) &&
			GET_CONFIG()->GetMemoAlarmType() == 2)
		{
			ReadNote(); 
		}


		GET_APP()->m_pReceivedNoteManager->DeleteRecvNoteFromSqlite((ULONG)m_lMemoID);

		result = true;
	}*/

///////////////////////////////////////////////////////////////////////////

	if (pMsg->message == WM_CLOSE && pMsg->hwnd == m_hWnd)
	{
		if(GET_CONFIG()->GetMemoAlarmType() == 2)
		{
			ReadNote(); 
		}
		GET_APP()->m_pReceivedNoteManager->DeleteRecvNoteFromSqlite((ULONG)m_lMemoID);
		result = true;
	}
	if (pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4)
	{
		if (g_pProfileWnd != NULL && IsWindow(g_pProfileWnd->GetHWND())&& m_ctrlMemoViewer.GetSafeHwnd() == g_pProfileWnd->GetParentHwnd())
		{
			g_pProfileWnd->CloseProfileWnd();
		}
		else{
			GET_APP()->m_pReceivedNoteManager->DeleteRecvNoteFromSqlite((ULONG)m_lMemoID);
			result = true;
		}
	}
	if(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) {

		if (GET_CONFIG()->GetMemoAlarmType() == 2)
		{
			ReadNote(); 
		}
		GET_APP()->m_pReceivedNoteManager->DeleteRecvNoteFromSqlite((ULONG)m_lMemoID);
		result = true;
	}

	return result;

}

void CRecvMemoDlg::StopFlashAndAdjustFocus()
{
	
	FlashWindowEx(FLASHW_STOP,0,0);
	m_bFlashFlag = false;

}

void CRecvMemoDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	ReadNote();
	__super::OnLButtonDown(nFlags, point);
}

void CRecvMemoDlg::OnNcLButtonDown(UINT nHitTest, CPoint point)
{
	ReadNote();
	__super::OnNcLButtonDown(nHitTest, point);
}

void CRecvMemoDlg::ReadNote()
{
	if( m_bReadStatus == false )
	{
		if( g_pMessengerActor->GetWASActor()->RequestNoteSetReadStatus( m_lMemoID, GetLanguageString().c_str(), &m_trid ) )
		{
			m_bReadStatus = true;

			int nCurCount = GET_MESSENGER_DLG()->GetMainFrame()->GetInfoItemNoteItemCount();
			GET_MESSENGER_DLG()->GetMainFrame()->SetInfoItemNoteItemCount(nCurCount - 1);
		}
	}
}

bool CRecvMemoDlg::OnResponseNoteSetReadStatus(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode)
{
	if( m_trid != trid )
		return true;

	// 무작정 재시도를 할 수는 없다(무한루프). 읽음 처리 실패에 대한 논의 필요.
	//if( eErrorCode != wasError_None )
	//{
	//	g_pMessengerActor->GetWASActor()->RequestNoteSetReadStatus( m_lMemoID, GetLanguageString().c_str(), &m_trid );
	//}

	return false;
}

bool CRecvMemoDlg::OnResponseDeleteNote(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bResult)
{
	if( m_trid != trid )
		return true;

	if( bResult != true )
	{
		GET_APP()->m_pMessageBoxManager->CreateMessageBox(this, _T("쪽지 삭제가 실패하였습니다. 잠시 후 다시 시도하세요.")/*LoadStringFromResource(IDS_STRING)*/);	// 다국어
	}

	return false;
}

void CRecvMemoDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == TIMER_TEST_SENDMEMO_AUTO_REPLY)
	{
		//KillTimer(nIDEvent);

		GET_APP()->m_pSendNoteManager->MakeMemoSendDlg(_T("reply"), m_lMemoID, this);

		m_noteCount++;
		TRACE("NoteSendCount = %d\n",m_noteCount);
	}
	__super::OnTimer(nIDEvent);
}

void CRecvMemoDlg::OnMenuTopMost()
{
	if (m_bTopMost)
	{
		m_bTopMost = FALSE;
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
	}
	else
	{
		m_bTopMost = TRUE;
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE);
	}
}

void CRecvMemoDlg::OnMenuReply()
{
	if (m_btnReply.GetSafeHwnd())
		OnBnClickedButtonReply();
}

void CRecvMemoDlg::OnMenuAllReply()
{
	if (m_btnAllReply.GetSafeHwnd())
		OnBnClickedButtonReplyall();
}

void CRecvMemoDlg::OnMenuForward()
{
	if (m_btnForward.GetSafeHwnd())
		OnBnClickedButtonForward();
}

void CRecvMemoDlg::OnMenuRecvDel()
{
	if (m_btnDel.GetSafeHwnd())
		OnBnClickedButtonDel();
}

void CRecvMemoDlg::OnMenuChat()
{
	if (m_btnIM.GetSafeHwnd())
		OnBnClickedButtonIm();
}

LRESULT CRecvMemoDlg::OnBnClickedRecvMemoMenuButton( WPARAM wParam, LPARAM lParam )
{
	CRect rectTopMenu(0, 0, 0, 0);
	rectTopMenu = GetCustomBtnRect();	

	CRect rtDlg(0, 0, 0, 0);
	GetWindowRect(&rtDlg);

	POINT pt = {0};
	pt.x = rtDlg.left + rectTopMenu.left;
	pt.y = rtDlg.top + rectTopMenu.bottom;

	CMenu menuList;
	menuList.LoadMenu(IDR_MENU_RECVMEMO);

	menuList.CheckMenuItem(ID_RECVMEMO_TOP, m_bTopMost ? MF_CHECKED : MF_UNCHECKED);
	menuList.EnableMenuItem(ID_RECVMEMO_REPLY, MF_ENABLED);
	menuList.EnableMenuItem(ID_RECVMEMO_ALLREPLY, MF_ENABLED);
	menuList.EnableMenuItem(ID_RECVMEMO_FORWARD, MF_ENABLED);
	menuList.EnableMenuItem(ID_RECVMEMO_DEL, MF_ENABLED);
	menuList.EnableMenuItem(ID_RECVMEMO_CHAT, MF_ENABLED);
	menuList.GetSubMenu(0)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);

	PostMessage(WM_NCMOUSELEAVE, 0, 0);

	return 0L;
}

void CRecvMemoDlg::_EnableAllBtnHandCurser()
{
	m_btnAllReply.EnableHandCursor(TRUE);
	m_btnDel.EnableHandCursor(TRUE);
	m_btnForward.EnableHandCursor(TRUE);
	m_btnIM.EnableHandCursor(TRUE);
	m_btnReply.EnableHandCursor(TRUE);
	m_btnPRT.EnableHandCursor(TRUE);
}
